SoPointDetail Class Reference

| http://www.sim.no/ http://www.coin3d.org/

- Main Page
- Related Pages
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | List of all members
SoPointDetail Class Reference
Detail Classes

The SoPointDetail class is for storing detailed information for a single 3D point.Instances of this class are used among other things for storing information about the vertices of lines and polygons after pick operations, and for storing information returned to tessellation callbacks. More...

`#include <Inventor/details/SoPointDetail.h>`

Inheritance diagram for SoPointDetail:

## Public Member Functions
virtual SoType | getTypeId (void) const
| SoPointDetail (void)
virtual | ~SoPointDetail ()
virtual SoDetail * | copy (void) const
int | getCoordinateIndex (void) const
int | getMaterialIndex (void) const
int | getNormalIndex (void) const
int | getTextureCoordIndex (void) const
void | setCoordinateIndex (const int idx)
void | setMaterialIndex (const int idx)
void | setNormalIndex (const int idx)
void | setTextureCoordIndex (const int idx)
Public Member Functions inherited from SoDetail
virtual | ~SoDetail ()
SbBool | isOfType (const SoType type) const

## Static Public Member Functions
static SoType | getClassTypeId (void)
static void | cleanupClass (void)
static void | initClass (void)
Static Public Member Functions inherited from SoDetail
static void | initClass (void)
static void | initClasses (void)
static SoType | getClassTypeId (void)

## Additional Inherited Members
Protected Member Functions inherited from SoDetail
| SoDetail (void)

## Detailed Description

The SoPointDetail class is for storing detailed information for a single 3D point.

Instances of this class are used among other things for storing information about the vertices of lines and polygons after pick operations, and for storing information returned to tessellation callbacks.

It contains indices into the vertex coordinate sets, along with indices into material, texture and normal coordinates for the point.

## Constructor & Destructor Documentation

SoPointDetail::SoPointDetail | ( | void |  | ) |

Sets up an empty detail instance (all indices are equal to 0).

SoPointDetail::~SoPointDetail | ( |  | ) |
| virtual

Destructor.

## Member Function Documentation

SoType SoPointDetail::getTypeId | ( | void |  | ) | const
| virtual

Returns the type identification of a detail derived from a class inheriting SoDetail. This is used for run-time type checking and "downward" casting.

Usage example:

void fuhbear(SoDetail * detail)
{
if (detail->getTypeId() == SoFaceDetail::getClassTypeId()) {
// safe downward cast, know the type
SoFaceDetail * facedetail = (SoFaceDetail *)detail;
}
return; // ignore if not a SoFaceDetail
}

For application programmers wanting to extend the library with new detail classes: this method needs to be overridden in all subclasses. This is typically done as part of setting up the full type system for extension classes, which is usually accomplished by using the pre-defined macros available through Inventor/nodes/SoSubDetail.h: SO_DETAIL_SOURCE and SO_DETAIL_INIT_CLASS.

Implements SoDetail.

SoDetail * SoPointDetail::copy | ( | void |  | ) | const
| virtual

Return a deep copy of ourself.

Note that if the Coin library has been built as a DLL under Microsoft Windows and you use this method from application code, you must make sure that both the Coin DLL and the application executable is using the same instance of a C Run-Time (CRT) library. Otherwise, you will get memory heap corruption upon deallocating the returned instances, eventually leading to mysterious crashes.

Implements SoDetail.

int SoPointDetail::getCoordinateIndex | ( | void |  | ) | const

Returns index into coordinate set for the point's 3D coordinates.

int SoPointDetail::getMaterialIndex | ( | void |  | ) | const

Returns point's index into set of materials.

int SoPointDetail::getNormalIndex | ( | void |  | ) | const

Returns point's index into set of normals.

int SoPointDetail::getTextureCoordIndex | ( | void |  | ) | const

Returns point's index into set of texture coordinates.

void SoPointDetail::setCoordinateIndex | ( | const int | idx | ) |

Used by client code for initializing the point detail instance.

void SoPointDetail::setMaterialIndex | ( | const int | idx | ) |

Used by client code for initializing the point detail instance.

void SoPointDetail::setNormalIndex | ( | const int | idx | ) |

Used by client code for initializing the point detail instance.

void SoPointDetail::setTextureCoordIndex | ( | const int | idx | ) |

Used by client code for initializing the point detail instance.

The documentation for this class was generated from the following files:

- SoPointDetail.h
- SoPointDetail.cpp

Copyright © 1998-2010 by Kongsberg Oil & Gas Technologies. All rights reserved.